//******************************************************************************
//
//                  GSM Modem Interface to ARM7 Development Board
//
//******************************************************************************
// FileName:        main.c
// Microcontroller: LPC2148
// Compiler:        Keil
// Target Hardware: ARM7 Development Board
// Company:         ENTESLA
//******************************************************************************
//                          Description                     
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// The firmware demonstrates SMS delivery system using a GSM Modem connected to  
// RS232-0 port of ARM7 Development Board.
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//                			 Hardware Settings
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//  Microcontroller:LPC2148
//  Ext.Oscillator:	12 MHz
//  Jumper Setting:	Set jumper JP2 to connect RXD0 and TXD0 to RS232-0	  
//
//  Switch Setting: None 
//
//	PINOUT:			GSM Modem  -   LPC2148 
//					---------------------- 
//					 	Rx			TXD0
//						Tx 			RXD0
//						GND			GND
//******************************************************************************
#include <lpc214x.h>

#include "adc.h"
#include "lcd.h"

//#include "systemInit.h"
//#include "delay.h"
#include <stdio.h>
#include "string.h"
#include "lcd1.h"
#include "serial.h"
#include "uart.h"


//**************************INCLUDES********************************************
#include "config.h"
#include "stdlib.h"
//**********************End of INCLUDES***************************************** 
//************************Private Protoype**************************************

#define BUZZER (1 << 25)
#define BUZZER_DIR IO1DIR
#define BUZZER_SET IO1SET
#define BUZZER_CLR IO1CLR

void delay2(int count);
void check(void);
#define TIMER_TICK_1_MS (59999) /* VPB at 60 MHz clock */

unsigned char buf[16] = {0};
int jack;
int adcValue;//x
int adcValue1;//y
int adcValue2;//z
int adcValue3;//for X difference
int adcValue4;//for Y difference
int adcValue5;//for Z difference

int delta_x;
int delta_y;
int delta_z;
int thx_x = 1;
int thx_y = 2;
int thx_z = 3;
static unsigned int s;                //holds sensor value
char ma[1];            
char sva[2];

void tostring(char str[], int num);
unsigned int delay3, adc, adc1, adc2;
char String[]="Wel-Come to BINARYUPDATES.COM, ADC and UART Configured @LPC2148 \n\r Serial Communication @ 9600 baudrate, 8 bits, no Parity, 1 Stop bit\n\r\n";
char Newline[]="\n\r\n";
//volatile int m;//
static unsigned int m;
char adcreading[16];
char adcreading1[16];
char adcreading2[16];

unsigned int TimerInit();


int b,sen;
float temp;
void sensor_detect(void);
void delayMS(unsigned int milliseconds);

void _DelayMs(unsigned int);
unsigned char GsmSendMsg(unsigned char *msgStr);
unsigned char GsmMakeCall(unsigned char *msgStr);
unsigned char GsmSendMsgFromStorage(unsigned char *msgStr);
unsigned char HttpRequest(unsigned char *msgStr,unsigned char *msgStr1,unsigned char *msgStr2);
unsigned char GPSMsgSensor(unsigned char *msgStr,unsigned char *msgStr1,unsigned char *msgStr2,unsigned char *msgStr3);
unsigned char GpsSendMsg(unsigned char *msgStr,unsigned char *msgStr1);


unsigned int Gpsinfo(unsigned char *msgStr);
unsigned char HttpRequestColon(unsigned char *msgStr,unsigned char *msgStr1,unsigned char *msgStr2);
unsigned char GsmInitialStart();
void HttpRequestInitial();
unsigned int sensordetect();

void float_to_string(float f, char r[]);
int n_tu(int number, int count);

void concat(char s1[], char s2[]);
void _DelayMs(unsigned int count);
char U0Read(void); 
//*******************End of Private Protoype************************************

//***********************Variable Declarations**********************************
unsigned char usrNumStr[20]="\"9999999999\"";	//Receiptent Mobile Number


char recepients[20][12] = { "9999999999","9999999999"};
int numberofreceipents;
char na[150];
int inital;
int count;
int k;
int id=1;
char idstr[3];
int n,l;//int m
char c;
void tostring(char str[], int num);
#define RDR (1<<0) // Receiver Data Ready
//*******************End of Variable Declarations******************************

//*****************************************************************************
// Function:        int main(void)
//
// Input:           None
//
// Output:          None
//
// Overview:        Main enrty point.
//
// Note:            None
//*****************************************************************************
int main(void)
{
	count=0; //index to holds the gsm output

  Uart0Init();//uart initalization for inter communicate with GSM
	init_lcd(); //initialization to display lcd 
//	 ADC_Init() ;
	lcd_clear();//clear lcd screen

	inital=1;  //to call gsm Http inital command 1st time and to activate it
 
	while(1)
	{
	c=' '; //read gsm characher output
	lcd_clear();
	lcd_putstring(0,"WELCOME TO GSM");

	lcd_putstring(1,"START");

	count=0;
	_DelayMs(1000);

	Gpsinfo("at+cgpsinf=0"); //GSM and GPS function
		
	}
}


//*****************************************************************************
// Function:        void _DelayMs(unsigned int count)
//
// Input:           Delay in milliseconds
//
// Output:          None
//
// Overview:        Generates a delay of specified number of milliseconds. 
//
// Note:            None
//*****************************************************************************
void _DelayMs(unsigned int count) 
{
    volatile unsigned int j,k;
    for (j=0;j<count;j++) 
	{
        for (k=0;k<6000;k++) 
		{
     		
     }
   }
}




//*****************************************************************************
// Function:       Gpsinfo(unsigned char *msgStr)
//
// Input:           GSM command String has passed
//
// Output:          return success or failure
//
// Overview:        It initalize Gsm & Gps as well read the Long & Latid values and send 
//                   throuh Http protocol.
// Note:            None
//*****************************************************************************


unsigned int Gpsinfo(unsigned char *msgStr)
{
	
	int succes;
	float longflo=0.0,latidflo=0.0;   //holds long and latid values
	char X[20],Y[20],Z[30],Long[20],log[2],Latid[20],latid[2],P[20],Q[20]; //array used to hold long and latid values from bunch of character output from gsm
	int lk,mk,Xcount=0,Ycount=0,Zcount=0,Longvalue=0,Latidvalue=0,Pcount=0,Qcount=0; //used for index values to hold long and latit values

   Uart0PutS(msgStr);
	 Uart0PutCh(0x0D);
	 
//reads the bunck of character output from gsm and holds into array
	 for (m=0;m<4000;m++) 
	 {
    for (k=0;k<6000;k++) 
		{
     c=Uart0GetCh();
	
    na[count]=c;
			count++;
     if(c=='O'||c=='N'||c=='E')	
  	 {
	  	na[count]=c;
			count++;
			for( n=0;n<1000;n++)
			{
			 c=Uart0GetCh();
			//lcd_putchar(c);
			 na[count]=c;
			 count++;	
			 if(c=='\r')
			 {
				goto end;
			 } //if end
			} //for end
		 } //if end
		}	//for end
	 }	//fpr end	
   end:

	 //holds long values from bunch of array 
	 for(lk=17;lk<28;lk++)
	 {
		 if(na[lk]!=',')
		 {
     X[Xcount]=na[lk];
		 Xcount++;
		 } 
	 }

	 
	 //holds latid values from bunch of array
	 for(lk=29;lk<40;lk++)
	 {
		if(na[lk]!=',') 
		{
     Y[Ycount]=na[lk];
		 Ycount++;
    } 	 
	}

	//add first 2 long and latid values into array
	log[0]=X[0];
	log[1]=X[1];
	latid[0]=Y[0];
	latid[1]=Y[1];
	
	//add remaing 8 long and latid values into another array to perform opertion which is compatible for Google-maps format
	for(mk=2;mk<=Xcount;mk++)
	{
	P[Pcount]=X[mk];
		Pcount++;
	}
	for(mk=2;mk<=Ycount;mk++)
	{
	Q[Qcount]=Y[mk];
		Qcount++;
	}
	//holds the date and time values into array Character Z
		 for(lk=52;lk<66;lk++)
	 {
		if(na[lk]!=',') 
		{
     Z[Zcount]=na[lk];
		 Zcount++;
    } 	 
	}
	 

//convert   2 character array as well 8 character array into integer ,
//divide LSB 8 integer values into 60 ,add it after the decimaal to form Google map format
//convert ddmm.mmmm into dd.mmmmmm by dividing mm.mmmm/60=0.mmmmmm
//convert decimal into character array inorder to transfer
	 Longvalue = atoi(log);
	 longflo=Longvalue+atof(P)/60;
	 float_to_string( longflo, Long);
	 
	 Latidvalue=atoi(latid);
	 latidflo=Latidvalue+atof(Q)/60;
	 float_to_string(latidflo,Latid);

	
	//if long and latitd values==0, not-detected ,means gps is not yet activated ,so it call GSM Inital Method
	//if detected call Http Function to transfer data.
	if((Latidvalue!=0)&&(Longvalue!=0))
	{
		succes=1;
HttpRequestColon(Long,Latid,Z);
	}
	if((Latidvalue==0)&&(Longvalue==0))
	{
		succes=0;
	GsmInitialStart();
	}
		// _DelayMs(3000);
	 return succes;
}


//*****************************************************************************
// Function:        HttpRequestColon()
//
// Input:           Receive input of Long , Latid &DateTime
//
// Output:          None
//
// Overview:        Message to be transmitted through IP to the destination SERVER.
//
// Note:            None
//*****************************************************************************

unsigned char HttpRequestColon(unsigned char *msgStr,unsigned char *msgStr1,unsigned char *msgStr2)
{
	
	char longname[10];   //holds long value
	char latidname[10];  //holds latid value
//	int s;             //holds sensor value
//	char ma[1];            
//	char sva[2];
	char datename[15];     //holds date and time Stamp
	
	//static format of HttpReguest, finally it append remaining parrameter and send to database
	char httpget[60]="\"http://106.51.46.73:8082/GPSTACKSTRUC2/opentracker.action?";   
	lcd_clear();

	tostring(idstr, id);
	tostring(longname,inital);
	
	lcd_putstring(0,"START_ACIDENT");

  s=TimerInit();//holds sensor value from sensor function

	if(s==2)
	{
	ma[0]='1';//to print sensor value 1 if it's detected
	}
	else{
	ma[0]='0';//to print sensor value 0 if it's not detected
	}
	
	tostring(sva,s);//to print sensor value on lcd
  
	lcd_clear();
	lcd_putstring(1,sva);//to print sensor value on lcd

//	delayMS(100);
	Uart0PutS("AT+CGATT=1");  //At command for TCP/IP activatin
	Uart0PutCh('\r');
//	_DelayMs(1000);

//check if Http Command activate or not ,if not it call HttpRequestInital function
//if activated, send all parameter(long,latitd,sensor,Timestamp)by appending into HttpRequest in Sim908 Format
	 if(inital==1)
	 {
 HttpRequestInitial();
	 }
	 else{
	Uart0PutS("AT+SAPBR=1,1");
	Uart0PutCh('\r');
	_DelayMs(1000); 
	Uart0PutS("AT+SAPBR=2,1");
	Uart0PutCh('\r');
	_DelayMs(100); 
	}
	  
	Uart0PutS("AT+HTTPPARA=\"URL\"");
	Uart0PutS(",");
	Uart0PutS(httpget);
	Uart0PutS("uid=");Uart0PutS(idstr);
	Uart0PutS(";");
	 Uart0PutS(msgStr);
	Uart0PutS(";");
	 Uart0PutS(msgStr1);
	Uart0PutS(";");
  Uart0PutS(ma);//to print sensor value on hypertext
	Uart0PutS(";");Uart0PutS(msgStr2);
	Uart0PutS("\"");
	Uart0PutCh('\r');
//  _DelayMs(100); 
	Uart0PutS("AT+HTTPACTION=0");
  Uart0PutCh('\r');
	 _DelayMs(2000);
	Uart0PutS("AT+HTTPREAD");
	Uart0PutCh('\r');
//	 _DelayMs(100);
//  _DelayMs(1000); 

id++;
if(s==1)
{m=0;}

}



//*****************************************************************************
// Function:        HttpRequestInitial()
//
// Output:          None
//
// Overview:        Http inital commands to activate TCP/IP in GSM module 
//
// Note:            None
//*****************************************************************************
void HttpRequestInitial()
{
	
	unsigned char GprsSettings[30]="\"APN\",""\"airtelgprs.com\"";
	unsigned char Gprsinitial[30]="\"Contype\",""\"GPRS\"";
	
	 inital=2;
		
	Uart0PutS("AT+SAPBR=3,1,");
	Uart0PutS(Gprsinitial);
	Uart0PutCh('\r');
	_DelayMs(100);  // timepass
	Uart0PutS("AT+SAPBR=3,1,");
	Uart0PutS(GprsSettings);
	Uart0PutCh('\r');
	_DelayMs(100);  // timepass
	Uart0PutS("AT+SAPBR=1,1");
	Uart0PutCh('\r');
	_DelayMs(1000); 
	Uart0PutS("AT+SAPBR=2,1");
	Uart0PutCh('\r');
	_DelayMs(100); 


	Uart0PutS("AT+HTTPINIT");
	Uart0PutCh('\r');
	_DelayMs(100); 
	Uart0PutS("AT+HTTPPARA=\"CID\",1");
	Uart0PutCh('\r');
	_DelayMs(100); 
		
	
}

void Timer_ISR(void) __irq//IRQ for sensor
{
			m=2;

	if(T1IR == 0x01)//added for interrupt enabling
	{
    T1IR = 1;

//		while(1)
//    {
//				init_lcd();
//				SystemInit();
		ADC_Init();       
		adcValue = ADC_GetAdcValue(AD0_1);//AD1_5[x] // Read the ADC value of channel zero where the temperature sensor(LM35) is connected
		adcValue1 = ADC_GetAdcValue(AD0_2);//y
		adcValue2 = ADC_GetAdcValue(AD0_4);//z //3

//			 sprintf(adcreading," X=%4d",adcValue-805);//sprintf((char *)buf,"\r X =%4d",result-477);
//								lcd_putstring(0, (char *)buf);
//			
//			 sprintf(adcreading1,"        Y=%4d",adcValue1-813);
//								lcd_putstring(0, (char *)buf);
//			
//			 sprintf(adcreading2,"			Z=%4d",adcValue2-501);//,a,b
//								lcd_putstring(1, (char *)buf);
       delayMS(10);
	
		adcValue3 = ADC_GetAdcValue(AD0_1); //AD1_5//X AXIS
		delta_x = adcValue - adcValue3;
		if (delta_x > thx_x)
		{
		BUZZER_DIR |= BUZZER;
		BUZZER_SET |= BUZZER;
		m=1;

		}

		adcValue4 = ADC_GetAdcValue(AD0_2); //Y AXIS
		delta_y = adcValue1 - adcValue4;
		if (delta_y > thx_y)
		{
		BUZZER_DIR |= BUZZER;        
		BUZZER_SET |= BUZZER;	
		m=1;

		}

		adcValue5 = ADC_GetAdcValue(AD0_4); //Z AXIS
		delta_z = adcValue2 - adcValue5;
		if (delta_z > thx_z)
		{
		BUZZER_DIR |= BUZZER;
		BUZZER_SET |= BUZZER;	
		m=1;
//sprintf((char *)buf, "s:%d ",m);
//lcd_putstring(1, (char *)buf);
		}

	if(m==2)//to come out of the loop
	{		
		m=0;
	}		 
		
	T1IR = 0x01;
	VICVectAddr = 0x00; 
	}
}

unsigned int TimerInit()
{

	T1TCR = 0x00;		/* ensure timer 1 is off */
	/* set timer counter and prescale counter */
	T1TC = 0x0;
	T1PC = 0x0;

	/* set prescale and match values to give 1 ms "tick" */
	T1PR = 0x0;
	T1MR0 = TIMER_TICK_1_MS;

	/* set control to interrupt on MR0 match, and reset to 0 (i.e. "tick") */
	T1MCR = 0x3;

	/* vector TIMER 1 as mid-level priority and enabled */
	VICVectCntl11 = 0x25;

	/* vector TIMER 1 interrupt address */
	VICVectAddr11 = (unsigned int) Timer_ISR;

	/* enable TIMER 1 in VIC */
	VICIntEnable = 0x0020;

	/* go start timer 1... */
	T1TCR = 0x1;
//	sprintf((char *)buf, "m:%d ",m);
//  lcd_putstring(1, (char *)buf);
    _DelayMs(10); //when this delay is added sensor value is detected and displays 1 on lcd and on hypertext it displays as 01

	return m;

}


//*****************************************************************************
// Function:        GsmInitialStart()
//
// Input:           
//
// Output:          None
//
// Overview:        It conatins a GSM command to inital the GPS as well GSM while start up
//
// Note:            None
//*****************************************************************************

unsigned char GsmInitialStart()
{
	char c=' ';
	Uart0PutS("at");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
Uart0PutS("at+cmgf=1");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
Uart0PutS("at+cgpspwr=1");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cgpsrst=1");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cfun=1");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cipshut");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
Uart0PutS("at+cipmux=0");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cgdcont=1,");
		Uart0PutS("\"IP\",");
		Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cgact=1,1");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
		Uart0PutS("at+cgatt=1");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cipstatus");
		Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cstt");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cipstatus");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
		Uart0PutS("at+ciicr");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cifsr");
		Uart0PutCh(0x0D);
		_DelayMs(1000);
	Uart0PutS("at+cgpsinf=0");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
		lcd_clear();
	lcd_putstring(0,"WAIT FOR");
		lcd_putstring(1,"30Min TO ACTIVE");
	_DelayMs(10000);
	lcd_clear();
	lcd_putstring(0,"WAIT FOR");
		lcd_putstring(1,"GPS TO ACTIVE");
	_DelayMs(10000*8);
_DelayMs(100000*8);
Uart0PutS("at+cgpsinf=0");
	Uart0PutCh(0x0D);
		_DelayMs(1000);
}


//*****************************************************************************
// Function:       tostring(char str[], int num)
//
// Input:           A array of character, positive integer value
//
// Output:          int value into array of character value.
//
// Overview:        Message to be transmitted with prefixes.
//
// Note:            None
//*****************************************************************************

void tostring(char str[], int num)

{
   int i, rem, len = 0, n;
    n = num;
    while (n != 0)
    {
     len++;
     n /= 10;     }
    for (i = 0; i < len; i++)
    {
     rem = num % 10;
     num = num / 10;
     str[len - (i + 1)] = rem + '0';
    }
   str[len] = '\0';
}

//*****************************************************************************
// Function:       float_to_string(float f, char r[])
//
// Input:           positive floating point number
//
// Output:          int value into array of character value.
//
// Overview:        Message to be transmitted with prefixes.
//
// Note:            None
//*****************************************************************************



void float_to_string(float f, char r[])
{
    long long int length, length2, i, number, position, sign;
    float number2;

    sign = -1;   // -1 == positive number
    if (f < 0)
    {
        sign = '-';
        f *= -1;    
    }   
    number2 = f;  
    number = f;
    length = 0;  // size of decimal part
    length2 = 0; //  size of tenth

    /* calculate length2 tenth part*/
    while( (number2 - (float)number) != 0.0 && !((number2 - (float)number) < 0.0) )
    {
         number2 = f * (n_tu(10.0, length2 + 1));
         number = number2;  

         length2++;
    }

    /* calculate length decimal part*/
    for(length = (f > 1) ? 0 : 1; f > 1; length++) 
        f /= 10;

    position = length;
    length = length + 1 + length2;
    number = number2;
    if(sign == '-')
    {
        length++;
        position++;
    }

    for(i = length; i >= 0 ; i--)
    {
        if(i == (length))
            r[i] = '\0';
        else if(i == (position))
            r[i] = '.';
        else if(sign == '-' && i == 0)
            r[i] = '-';
        else  
        {
            r[i] = (number % 10) + '0';
            number /=10;
        }
    }
}

int n_tu(int number, int count)
{
    int result=1;
    while(count-- > 0)
    result *= number;   

    return result;
}

void delayMS(unsigned int milliseconds)
{
	/*Assuming that PLL0 has been setup with CCLK = 60Mhz and PCLK also = 60Mhz.*/
	
	T0CTCR = 0;
	T0PR = 60000; //60000 clock cycles = 1 mS @ 60Mhz

	T0TCR = 0x02; //Reset Timer
	T0TC = 0;
	T0TCR = 0x01; //Enable timer
	
	while(T0TC < milliseconds); //wait until timer counter reaches the desired delay
	
	T0TCR = 0x00; //Disable timer
}

